package uk.ac.cam.aa582.structures.boxes;

/**
 * Used to communicate the sizes of various symbols such as
 * integral signs or brackets
 * 
 * @author Ahmad Akra
 *
 */
public enum Size {
	
	/**
	 * Size tiny
	 */
	tiny,
	
	/**
	 * Size small
	 */
	small,
	
	/**
	 * Size medium
	 */
	medium,
	
	/**
	 * Size large
	 */
	large,
	
	/**
	 * Size x-large
	 */
	xlarge,
	
	/**
	 * Size extended, when size x-large is not large enough,
	 * and extensions are used
	 */
	extended	
}
