About
-----

wxWidgets is a free and open source cross-platform C++ framework
for writing advanced GUI applications using native controls.

![wxWidgets Logo](http://www.wxwidgets.org/assets/img/header-logo.png)


wxWidgets allows you to write native-looking GUI applications for
all the major desktop platforms and also helps with abstracting
the differences in the non-GUI aspects between them. It is free
for the use in both open source and commercial applications, comes
with the full, easy to read and modify, source and extensive
documentation and a collection of more than a hundred examples.
You can learn more about wxWidgets at http://www.wxwidgets.org/
and read its documentation online at http://docs.wxwidgets.org/


Platforms
---------

wxWidgets currently supports the following primary platforms:

- Windows XP, Vista, 7 and 8 (32/64 bits).
- Most Unix variants using the GTK+ toolkit (version 2.6 or newer or 3.x).
- Mac OS X (10.6 or newer) using Cocoa (32/64 bits) or Carbon (32 only).

Most popular C++ compilers are supported including but not limited to:

- Microsoft Visual C++ 2003 or later (up to 2013).
- g++ 3.4 or later, including MinGW/MinGW-64/TDM under Windows.
- Clang under OS X and Linux.
- Intel icc compiler.
- Oracle (ex-Sun) aCC.


Licence
-------

[wxWidgets licence](https://github.com/wxWidgets/wxWidgets/blob/master/docs/licence.txt)
is a modified version of LGPL explicitly allowing not distributing the sources
of an application using the library even in the case of static linking.


Further information
-------------------

If you are looking for support, you can get it from

- wx-users [mailing list](http://www.wxwidgets.org/support/mailing-lists/)
- wxForum at http://forums.wxwidgets.org/
- #wxwidgets IRC channel
- http://stackoverflow.com/ if you tag your question with "wxwidgets"
- Please report bugs at http://trac.wxwidgets.org/newticket

We would also gladly welcome [your contributions](CONTRIBUTING.md).


Have fun!

The wxWidgets Team.
